*---------------------------------------------------------------------------
*
* Demo for PrintEase, copyright (c) 1991,1992 DataEnter, Michael Kocum
*
* PrintEase includes a runtime version of Class(y), which
* is published by Integrated Development Corporation.
*
*---------------------------------------------------------------------------
#include "PE.CH"
#include "INKEY.CH"
*---------------------------------------------------------------------------
FUNCTION MAIN()
memvar getlist
LOCAL nAction,nPrintDevice,nTyp,cDevice,cPDFFile,cOldScreen,nLpt
LOCAL aQueue := {},nQueue,lAutoDetectANovellQueue,nAutoDetect
*
SET SCOREBOARD OFF
*
SETCOLOR(COLORSET(3))
@ 0,0 SAY PADR(" PrintEase Demo Ver: 1.10     Copyright (c) 1991,1992  DataEnter, Michael Kocum",80)
@ 24,0 SAY PADR(" PrintEase, printing has never been that easy...",80)
SETCOLOR(COLORSET(2))
@ 1,0,23,79 BOX  ""
SETCOLOR(COLORSET(1))
*
SIMPLEBOX(.T.,3,5,9,26)
DO WHILE .T.
   @ 5,7 PROMPT " Print a report  "
   @ 6,7 PROMPT " Print a barcode "
   @ 7,7 PROMPT " Print labels    "
   MENU TO nAction
   *
   IF LASTKEY() == K_ESC
      exit
   ENDIF
   SIMPLEBOX(.T.,7,10,15,44)
   DO WHILE .T.
      @  9,12 SAY " Select printer:"
      @  9,29 PROMPT " Epson       "
      @ 10,29 PROMPT " IBM Graphic "
      @ 11,29 PROMPT " HP Laserjet "
      @ 12,29 PROMPT " HP Deskjet  "
      @ 13,29 PROMPT " Postscript  "
      MENU TO nTyp
      IF LASTKEY() == K_ESC
         exit
      ENDIF
      SIMPLEBOX(.T.,10,26,18,59)
      DO WHILE .T.
         @ 12,28 SAY " Select device:"
         @ 12,44 PROMPT " LPT1         "
         @ 13,44 PROMPT " LPT2         "
         @ 14,44 PROMPT " LPT3         "
         @ 15,44 PROMPT " File         "
         @ 16,44 PROMPT " Novell Queue "
         MENU TO nPrintDevice
         IF LASTKEY() == K_ESC
            exit
         ENDIF
         *
         * now we have all what we need
         *
         nLpt := 0                              && reset LPT to zero
         lAutoDetectANovellQueue := .f.                   && Reset to normale
         DO CASE
         CASE nPrintDevice == 5
            aQueue := NE():NEW():ScanFQuName()
            IF LEN(aQueue) == 0  && No Queue
               MESS(" Oop's, there is no Novell Queue.")
               LOOP
            ELSE
               SIMPLEBOX(.T.,15,31,22,77)
               nQueue := ACHOICE(16,32,21,76,aQueue)
               IF nQueue == 0
                  SIMPLEBOX(.F.)
                  LOOP
               ENDIF
               *
               cDevice := aQueue[nQueue]
               lAutoDetectANovellQueue := .t.                   && Set to queue
               SIMPLEBOX(.F.)
            ENDIF
         CASE nPrintDevice == 4
            *
            * User wants to print in a file
            *
            cDevice := PADR("OUTPUT.PRN",12)
            SIMPLEBOX(.T.,15,31,19,61)
            @ 17,33 SAY "Print to file:" GET cDevice  PICTURE "@!"
            READ
            SIMPLEBOX(.F.)
            IF LASTKEY() == K_ESC
               exit
            ENDIF
            cDevice := ALLTRIM(cDevice)
         OTHERWISE
            *
            * Make a valid DOS device
            *
            cDevice := "LPT" + LTRIM(STR(nPrintDevice))
            nLpt := nPrintDevice
            *
            SIMPLEBOX(.T.,15,31,20,69)
            @ 17,33 PROMPT " Do not Autodetect a Novell Queue "
            @ 18,33 PROMPT " Autodetect a Novell Queue        "
            MENU TO nAutoDetect
            *
            IF nAutoDetect == 0
               SIMPLEBOX(.F.)
               LOOP
            ENDIF
            lAutoDetectANovellQueue := (nAutoDetect == 2)
            SIMPLEBOX(.F.)
            *
         ENDCASE
         DO CASE
         CASE nTyp == 1
            cPDFFile := "EPSON"
         CASE nTyp == 2
            cPDFFile := "IBM"
         CASE nTyp == 3
            cPDFFile := "HPLJII"
         CASE nTyp == 4
            cPDFFile := "HPDESKJ"
         CASE nTyp == 5
            cPDFFile := "PS"
         ENDCASE
         *
         cOldScreen := SAVESCREEN(1,0,23,79)
         SETCOLOR(COLORSET(2))
         @ 1,0,23,79 BOX  ""
         SETCOLOR(COLORSET(1))
         @ 24,79 SAY ""
         *
         DO CASE
         CASE nAction == 1
            DEMOREPORT(cPDFFile,cDevice,nLpt,lAutoDetectANovellQueue)
         CASE nAction == 2
            DEMOBARCODE(cPDFFile,cDevice,nLpt,lAutoDetectANovellQueue)
         CASE nAction == 3
            DEMOLABEL(cPDFFile,cDevice,nLpt,lAutoDetectANovellQueue)
         ENDCASE
         RESTSCREEN(1,0,23,79,cOldScreen)
         *
      ENDDO
      SIMPLEBOX(.F.)
   ENDDO
   SIMPLEBOX(.F.)
ENDDO
SIMPLEBOX(.F.)
SET COLOR TO
CLEAR
QUIT
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION COLORSET(nPos)
STATIC aColor := {"W/B,N/BG,N,N,GR+/B","W+/B","N/BG"}
STATIC aMono  := {"W/N,N/W,N,N,W+/N","W+/N","N/W"}
IF ISCOLOR()
   RETURN(aColor[nPos])
ENDIF
RETURN(aMono[nPos])
*---------------------------------------------------------------------------
FUNCTION SIMPLEBOX(lOpen,nTop,nLeft,nBottom,nRight)
STATIC aBox := {}
IF lOpen
   AADD(aBox,{nTop,nLeft,nBottom,nRight,SAVESCREEN(nTop,nLeft,nBottom,nRight)} )
   @ nTop,nLeft,nBottom,nRight BOX  "Ŀ "
ELSE
   RESTSCREEN(aBox[len(aBox)][1],aBox[len(aBox)][2],aBox[len(aBox)][3],;
   aBox[len(aBox)][4],aBox[len(aBox)][5])
   ASIZE(aBox,LEN(aBox)-1)
ENDIF
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION MESS(cMess)
SETCOLOR(COLORSET(3))
@ 24,0 SAY PADR(cMess,80)
?? CHR(7)                                       && beep one time
INKEY(0)                                        && wait for a key
SETCOLOR(COLORSET(1))
@ 24,0 SAY SPACE(80)
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION DEMOLABEL(cPDFFile,cDevice,nLpt,lAutoDetectANovellQueue)
STATIC aLabel := {"Line one","Line two","Line Tree"}
LOCAL oPE,ni,nz
*
* for endless label printing we use PELinePrint
*
IF nLpt == 0 .OR. PECHECK(nLpt)                 && check port
   *
   oPE := PELINEPRINT():NEW(cPDFFile,cDevice)   && Create class
   *
   * define a optional error codeblock, where we can catch errors
   *
   oPE:ErrorBlock := {|oObj| MYERROR(oObj)}
   *
   * define a optional warning codeblock, so we can debug it
   *
   oPE:WarningBlock := {|oObj| MYWARNING(oObj)}
   *
   * define a optional info codeblock, so the user will see whats on
   *
   oPE:InfoBlock := {|oObj| LINEPINFO(oObj)}
   *
   * Set Autodetect on
   *
   oPe:AutoPrintToQueue := lAutoDetectANovellQueue   && AutoPrint enabled
   *
   * Now loop though the array and print something
   *
   BEGIN SEQUENCE
      *
      oPE:UNDERLINE(.T.)                        && enable underline
      oPE:BOLD(.T.)                             && enable bold
      oPE:PRINT("PrintEase, copyright (c) 1991,1992 DataEnter, Michael Kocum")
      oPE:UNDERLINE(.F.)                        && diable underline
      oPE:BOLD(.F.)                             && disable bold
      oPE:PRINT("")                             && make a newline only
      oPE:PRINT("")                             && make a newline only
      oPE:PRINT("")                             && make a newline only
      oPE:PRINT("")                             && make a newline only
      oPE:PRINT("sample label")                 && make a newline only
      oPE:PRINT("")                             && make a newline only
      oPE:PRINT("")                             && make a newline only
      oPE:PRINT("")                             && make a newline only
      *
      FOR nz := 1 TO 5
         FOR ni := 1 TO 3
            *
            * This call is the same as:
            *
            * ? space(5) + aLabel[ni]
            *
            oPE:PRINT(SPACE(5) + aLabel[ni])
         NEXT
         oPE:PRINT("")                          && make a newline only
      NEXT
      *
      * Tell the class, that we are finished
      *
      oPE:END()
   END
ELSE
   MESS(" Oop's, there is an error in the printer.")
ENDIF
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION MYERROR(oPE)
*
* This function will be called in case of an error.
*
* In this demo we will only break out after leaving a message to the user.
*
DO CASE
CASE oPE:ErrorMessage == PE_ERROR_CantOpenDevice
   MESS(" Can't open device")
   break
CASE oPE:ErrorMessage == PE_ERROR_CantWriteToDevice
   MESS(" Can't write to  device")
   break
ENDCASE
RETURN(NIL)
*----------------------------------------------------------------------------
FUNCTION MYWARNING(oPE)
*
* This function will be called in case of an warning.
*
* Are only usefule in debugging, at runtime the class will handle
* mostly of them
*
* In this demo we only leave a message to the user.
*
DO CASE
CASE oPE:WarningMessage == PE_WARNING_NotAValidDevice
   MESS(" Device is not valid")
CASE oPE:WarningMessage == PE_WARNING_CantWriteToDevice
   MESS(" Can't write all to device, because device is to slow")
CASE oPE:WarningMessage == PE_WARNING_ColPastPage
   MESS(" You want to print out of the paper")
CASE oPE:WarningMessage == PE_WARNING_ColPastLastCol
   MESS(" You forget a NEWLINE()")
CASE oPE:WarningMessage == PE_WARNING_BarCodePastPage
   MESS(" Barcode is  to  long for this page")
CASE oPE:WarningMessage == PE_WARNING_NotAValidPaper
   MESS(" This is not a valid paper tray")
CASE oPE:WarningMessage == PE_WARNING_NotAValidLinespacing
   MESS(" This is not a valid linespacing")
CASE oPE:WarningMessage == PE_WARNING_CantOpenPDF
   MESS(" Can't open PDFFile")
CASE oPE:WarningMessage == PE_WARNING_NotAPDF
   MESS(" This is not a PDFFile")
ENDCASE
RETURN(NIL)
*----------------------------------------------------------------------------
FUNCTION LINEPINFO(oPE)
*
* this function helps the user waiting for the printer
*
LOCAL nOldCursor := SETCURSOR(0)
DO CASE
CASE oPE:InfoMessage == PE_INFO_StartOfJob
   *
   * Open box
   *
   SIMPLEBOX(.T.,7,15,7 + 4,15 + 35)
   @ 9,17 SAY "Characters sent:"
CASE oPE:InfoMessage == PE_INFO_EndOfJob
   *
   * we can only display characters sent, because we have no
   * other useful information
   *
   SETCOLOR(COLORSET(2))
   @ 9,35 SAY PADR(LTRIM(STR(oPE:CharsSent)),8)
   SETCOLOR(COLORSET(1))
   *
   * Close box
   *
   SIMPLEBOX(.F.)
OTHERWISE
   *
   * we can only display characters sent, because we have no
   * other useful information
   *
   SETCOLOR(COLORSET(2))
   @ 9,35 SAY PADR(LTRIM(STR(oPE:CharsSent)),8)
   SETCOLOR(COLORSET(1))
ENDCASE
SETCURSOR(nOldCursor)
@ 24,79 SAY ""
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION PAGEPINFO(oPE)
*
* this function helps the user waiting for the printer
*
* In PEPagePrint we have more information, so we can design a pretty
* screen.
*
STATIC nMaxRows := 0
LOCAL nOldCursor := SETCURSOR(0),nBarLen
DO CASE
CASE oPE:InfoMessage == PE_INFO_StartOfJob
   *
   * open a box
   *
   SIMPLEBOX(.T.,7,15,7 + 9,15 + 43)
   @ 7 + 2,15 + 2 SAY "           Page:"
   @ 7 + 3,15 + 2 SAY "           Line:"
   @ 7 + 4,15 + 2 SAY "Characters sent:"
CASE oPE:InfoMessage == PE_INFO_Character
   *
   * Print information about current row
   *
   SETCOLOR(COLORSET(2))
   @ 7 + 3,15 + 20 SAY PADR(LTRIM(STR(oPE:ROW())),3)
   @ 7 + 4,15 + 20 SAY PADR(LTRIM(STR(oPE:CharsSent)),8)
   SETCOLOR(COLORSET(1))
   *
   * calculate percent of page
   *
   nBarLen := INT(( nMaxRows - oPE:ROWSREMAIN()) / ( nMaxRows / 40))
   @ 7 + 7,15 + 2  SAY REPLICATE("",IF(nBarLen < 40,nBarLen,40))
CASE oPE:InfoMessage == PE_INFO_StartOfPage
   *
   * save max rows, so that we can calulate percent of page
   *
   nMaxRows := oPE:ROWSREMAIN()                 && Save it
   @ 7 + 6,15 + 2 SAY "         25%       50%       75%"
   @ 7 + 7,15 + 2 SAY REPLICATE("-",40)
   @ 7 + 7,15 + 2  + 10 SAY "+"
   @ 7 + 7,15 + 2  + 20 SAY "+"
   @ 7 + 7,15 + 2  + 30 SAY "+"
   SETCOLOR(COLORSET(2))
   @ 7 + 2,15 + 20 SAY PADR(LTRIM(STR(oPE:Pageno)),3)
   SETCOLOR(COLORSET(1))
CASE oPE:InfoMessage == PE_INFO_EndOfPage
   @ 7 + 7,15 + 2  SAY REPLICATE("",40)
CASE oPE:InfoMessage == PE_INFO_EndOfJob
   *
   * close box
   *
   SIMPLEBOX(.F.)
ENDCASE
SETCURSOR(nOldCursor)
@ 24,79 SAY ""
RETURN(NIL)
*----------------------------------------------------------------------------
FUNCTION DEMOBARCODE(cPDFFile,cDevice,nLpt,lAutoDetectANovellQueue)
LOCAL oPE
*
* For barcode we can use PEPagePrint or PELinePrint
* In this demo let's use PEPagePrint
*
*
IF nLpt == 0 .OR. PECHECK(nLpt)                 && check port
   *
   oPE := PEPAGEPRINT():NEW(cPDFFile,cDevice)   && Create class
   *
   * define a optional error codeblock, where we can catch errors
   *
   oPE:ErrorBlock := {|oObj| MYERROR(oObj)}
   *
   * define a optional warning codeblock, so we can debug it
   *
   oPE:WarningBlock := {|oObj| MYWARNING(oObj)}
   *
   * define a optional info codeblock, so the user will see whats on
   *
   oPE:InfoBlock := {|oObj| PAGEPINFO(oObj)}
   *
   * Set Autodetect on
   *
   oPe:AutoPrintToQueue := lAutoDetectANovellQueue   && AutoPrint enabled
   *
   * Now lets print it
   *
   BEGIN SEQUENCE
      oPE:COL(5)                                && move to col 5
      oPE:UNDERLINE(.T.)                        && enable underline
      oPE:BOLD(.T.)                             && enable bold
      oPE:PRINT("PrintEase, copyright (c) 1991,1992 DataEnter, Michael Kocum")
      oPE:UNDERLINE(.F.)                        && diable underline
      oPE:BOLD(.F.)                             && disable bold
      oPE:NEWLINE(4)                            && move down four lines
      oPE:COL(5)                                && move to col 5
      oPE:PRINT("sample barcode")               && print a information
      oPE:NEWLINE(4)                            && four line down
      oPE:COL(5)                                && move to col 5
      oPE:PRINT("Barcode 2/5 Int")              && print text
      oPE:COL(25)                               && move to col 25
      oPE:BCPRINT(PE25INT("12345"),10,4)        && print a barcode 10 colummns x 4 lines
      oPE:NEWLINE(2)                            && two lines down
      *
      oPE:COL(5)                                && move to col 5
      oPE:PRINT("Barcode EAN 13")
      oPE:COL(25)                               && move to col 25
      oPE:BCPRINT(PEEAN13("4974365610098"),13,4)      && print a barcode 13 colummns x 4 lines
      oPE:NEWLINE(2)
      *
      oPE:COL(5)                                && move to col 5
      oPE:PRINT("Barcode EAN 8")
      oPE:COL(25)                               && move to col 25
      oPE:BCPRINT(PEEAN8("50123452"),10,4)      && print a barcode 10 colummns x 4 lines
      oPE:NEWLINE(2)
      *
      oPE:COL(5)                                && move to col 5
      oPE:PRINT("Barcode UPC 12")
      oPE:COL(25)                               && move to col 25
      oPE:BCPRINT(PEUPC12("123456789012"),12,4) && print a barcode 12 colummns x 4 lines
      oPE:NEWLINE(2)
      *
      oPE:COL(5)                                && move to col 5
      oPE:PRINT("Barcode 3/9")
      oPE:COL(25)                               && move to col 25
      oPE:BCPRINT(PE39("12345"),10,4)           && print a barcode 10 colummns x 4 lines
      oPE:NEWLINE(2)
      *
      oPE:END()                                 && end printing
   END
ELSE
   MESS(" Oop's, there is an error in the printer.")
ENDIF
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION DEMOREPORT(cPDFFile,cDevice,nLpt,lAutoDetectANovellQueue)
LOCAL oPE,ni
*
* Now we simulating a report with PEPagePrint
*
*
IF nLpt == 0 .OR. PECHECK(nLpt)                 && check port
   *
   oPE := PEPAGEPRINT():NEW(cPDFFile,cDevice)   && Create class
   *
   * define a optional error codeblock, where we can catch errors
   *
   oPE:ErrorBlock := {|oObj| MYERROR(oObj)}
   *
   * define a optional warning codeblock, so we can debug it
   *
   oPE:WarningBlock := {|oObj| MYWARNING(oObj)}
   *
   * define a optional info codeblock, so the user will see whats on
   *
   oPE:InfoBlock := {|oObj| PAGEPINFO(oObj)}
   *
   * define a function to create a job header, printed on beginning of a job
   *
   oPE:JobHeader := {|oObj| JOBHEADER(oObj)}
   *
   * define a function to create a page header, printed on beginning of a page
   *
   oPE:PageHeader := {|oObj| PAGEHEADER(oObj)}
   *
   * define a function to create a page footer, printed after the last line
   * of a page
   *
   oPE:PageFooter := {|oObj| PAGEFOOTER(oObj)}
   *
   * define a function to create a job footer, printed on the last page
   * after the page footer
   *
   oPE:JobFooter := {|oObj| JOBFOOTER(oObj)}
   *
   * Set Autodetect on
   *
   oPe:AutoPrintToQueue := lAutoDetectANovellQueue   && AutoPrint enabled
   *
   * Now lets print our lines
   *
   BEGIN SEQUENCE
      FOR ni := 1 TO 80                         && make two pages
         oPE:COL(5)                             && move to col 5
         oPE:PRINT("This is line")
         oPE:COL(oPE:COL() + 1)                 && Shift one right
         oPE:BOLD(.T.)                          && enable bold printing
         oPE:PRINT(oPE:ROW(),"99")              && print row
         oPE:BOLD(.F.)                          && disable bold printing
         oPE:COL(oPE:COL() + 1)                 && Shift one right
         oPE:PRINT("in our")
         oPE:COL(oPE:COL() + 1)                 && Shift one right
         oPE:SHADE(.T.)                         && enable shade
         oPE:PRINT("PrintEase")
         oPE:SHADE(.F.)                         && disable shade
         oPE:COL(oPE:COL() + 1)                 && Shift one right
         oPE:PRINT("report sample.")
         oPE:NEWLINE()                          && make a new line
      NEXT
      *
      oPE:END()                                 && end printing
   END
ELSE
   MESS(" Oop's, there is an error in the printer.")
ENDIF
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION JOBHEADER(oPE)
*
* this part will be printed only on top of first page of our sample report
*
oPE:COL(5)                                      && move to col 5
oPE:UNDERLINE(.T.)                              && enable underline
oPE:BOLD(.T.)                                   && enable bold
oPE:PRINT("PrintEase, copyright (c) 1991,1992 DataEnter, Michael Kocum")
oPE:UNDERLINE(.F.)                              && diable underline
oPE:BOLD(.F.)                                   && disable bold
oPE:NEWLINE(2)                                  && move down two lines
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION PAGEHEADER(oPE)
*
* this part will be printed on top of every page of our sample report
*
oPE:COL(5)                                      && move to col 5
oPE:PRINT("sample report")
oPE:COL(56)                                     && move to col 56
oPE:PRINT("Page:")
oPE:COL(oPE:COL() + 1)                          && Shift one right
oPE:BOLD(.T.)                                   && enable bold
oPE:PRINT(oPE:Pageno,"99")
oPE:BOLD(.F.)                                   && disable bold
oPE:NEWLINE(2)                                  && move down two lines
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION PAGEFOOTER(oPE)
*
* this part will be printed after the last line of every page
*
oPE:NEWLINE(2)                                  && move down two lines
oPE:COL(5)                                      && move to col 5
oPE:BOLD(.T.)                                   && enable bold
oPE:PRINT("PrintEase")
oPE:BOLD(.F.)                                   && disable bold
oPE:PRINT(", printing has never been that easy...")
oPE:NEWLINE()
RETURN(NIL)
*---------------------------------------------------------------------------
FUNCTION JOBFOOTER(oPE)
*
* this part will be printed after the last line of the last page
*
oPE:NEWLINE(2)                                  && move down two lines
oPE:COL(5)                                      && move to col 5
oPE:PRINT("Thank you for printing the PrintEase sample report.")
oPE:NEWLINE()
RETURN(NIL)
*---------------------------------------------------------------------------
